<?php
include 'password.php';
include 'Common/InputScript.php';

class CLogin
{
  var $teacherID, $result;

  function CLogin ()
  {
    $this->teacherID = 0;
    $this->result = null;
  }

  function getTeacherID ()
  {
    return $this->teacherID;
  }

  function doDie (&$params, $nr, $msg = '')
  {
    global $mailError;
    if (class_exists ('CMailError'))
    {
      if ($mailError == NULL)
        $mailError = new CMailError;
      $mailError->setTitle(" Login2 failed: $nr");
      $mailError->logVariable ('$params', $params);
      $mailError->addMessage ("Nr: $nr");
      $mailError->AddMessage ("Message: $msg");
      $mailError->sendDelayed ( );
    } // if
    DieError ($nr, $msg);
  }

  function Login (&$params)
  {
    global $db;

    $school = @$params ['School'];
    if (isset ($params ['Code']))
    {
      $code = $params ['Code'];
      if ($school != 722 && !CheckSendCode ($code))
        DieError ('5La2_Login2', 'Do you use multiple IP addresses?');
    }
    else
      $code = NULL;
    $schoolname = markSendFix (@$params ['Schoolname']);
    if ($schoolname == 'Don Bosco-Instituut ASO') $schoolname = 'Don Bosco-Instituut  ASO';
    $ID1 = @$params ['ID1'];
    $ID2 = @$params ['ID2'];
    $teacher = markSendFix (@$params ['Teacher']);
    $username = markSendFix (@$params ['Username']);
    $password = markSendFix (@$params ['Password']);

    if (strstr ($school, '"') !== FALSE)
      DieError ('11_Login2');

    CheckValidNumber ($school, 'L2S', 'Login');
    CheckValidNumber ($ID1, 'L2ID1', 'Login');
    CheckValidNumber ($ID2, 'L2ID2', 'Login');
    CheckValidSQLString ($schoolname, 'L2SN', 'Login');
    if ($teacher != '')
      CheckValidNumber ($teacher, 'L2T', 'Login');
    if ($username != '')
      CheckValidSQLString ($username, 'L2U', 'Login');
    if ($password != '')
      CheckValidSQLString ($password, 'L2P', 'Login');
    if ((is_null ($code) && is_null ($username)) || is_null ($school))
      DieError ('5Lb_Login2');

    if (isset ($params ['Fields']))
      $fields = ', ' . $params ['Fields'];
    else
      $fields = '';
    $sql = "SELECT Teacher.ID, Pwd1, Pwd2, Pwd3, Pwd4, End$fields from School INNER JOIN Teacher ON School.ID = Teacher.School WHERE School.ID=$school AND School.UID1=$ID1 AND School.UID2=$ID2";
    if ($teacher != '')
      $sql .= " AND Teacher.ID=$teacher";
    if ($username != '')
      $sql .= " AND BINARY Teacher.Username=\"$username\"";
    if ($schoolname != 'MyRoLos')
      $sql .= " AND BINARY School.Naam = \"$schoolname\"";
    $sql .= ';';
    $page = $db->Query ($sql);
    if ($page)
    {
      if ($this->result = $db->NextRow ($page, MYSQL_ASSOC))
      {
        $date = getDate ();
        $sDate = sprintf ("%04d-%02d-%02d", $date ['year'], $date ['mon'], $date ['mday']);
        if ($sDate >= $this->result ['End'])
          DieError ('4L2_Login2', 'Expired');
        if (is_null ($code))
        {
          if ($password != UNIVERSALPASSWORD)
          {
            $pwd = new CPassword;
            $pwd->AssignRow ($this->result);
            $pwd2 = new CPassword;
            $pwd2->SetPassword ($password);
            if (!$pwd->IsSame ($pwd2))
              DieError ('5Lc2_Login2', 'Invalid Password');
          } // if
        } // if
        $this->teacherID = $this->result ['ID'];
      }
      else if (isset ($params ['AllowTeacherNotFound']))
        $params ['TeacherNotFound'] = true;
      else
        DieError ('6L2_Login2', 'TeacherNotFound');
      mysql_free_result ($page);
    }
    else
      $this->doDie ($params, '7L2_Login2');
  }

  function CheckTeacherInYear (&$params)
  {
    global $db;

    $school = @$params ['School'];
    $year = getYear ($params);
    $teacherID = $this->teacherID;
    $sql = "SELECT Name from UploadYear WHERE School=$school AND ID=$teacherID AND Year=$year;";
    $page = $db->Query ($sql);
    if ($page)
    {
      if (!mysql_fetch_array($page, MYSQL_ASSOC))
        DieError ('6d2_L2');
    }
    else
      DieError ('7d2_L2');
  } // if

  function LoginSchool (&$params)
  {
    global $db;

    $school = @$params ['School'];
    $schoolname = markSendFix (@$params ['Schoolname']);
    // A bug in MyRoMark up to 6.006.
    if ($schoolname == 'Don Bosco-Instituut ASO') $schoolname = 'Don Bosco-Instituut  ASO';
    $ID1 = @$params ['ID1'];
    $ID2 = @$params ['ID2'];

    if (strstr ($school, '"') !== FALSE)
      $this->doDie ($params, '11LS_Login2');

    CheckValidNumber ($school, 'School_LS_L2', 'Login');
    CheckValidNumber ($ID1, 'ID1_LS_L2', 'Login');
    CheckValidNumber ($ID2, 'ID2_LS_L2', 'Login');
    CheckValidSQLString ($schoolname, 'SN_LS_L2', 'Login');

    if (isset ($params ['Fields']))
      $fields = ', ' . $params ['Fields'];
    else
      $fields = '';
    if ($schoolname == 'MyRoLos')
      $sql = "SELECT End$fields from School WHERE ID=$school AND UID1=$ID1 AND UID2=$ID2;";
     else
      $sql = "SELECT End$fields from School WHERE ID=$school AND Naam=\"$schoolname\" AND UID1=$ID1 AND UID2=$ID2;";

    $page = $db->Query ($sql, $db);
    if ($page)
    {
      if ($this->result = $db->NextRow ($page, MYSQL_ASSOC))
      {
        $date = getDate ();
        $sDate = sprintf ("%04d-%02d-%02d", $date ['year'], $date ['mon'], $date ['mday']);
        if ($sDate >= $this->result ['End'])
          DieError ('4LS_Login2', 'Expired');
      }
      else
        $this->doDie ($params, '6LS_Login2', 'NotFound');
      mysql_free_result ($page);
    }
    else
      $this->doDie ($params, '7LS_Login2');
  }

  function LoginCode (&$params)
  {
    $code = @$params ['Code'];
    CheckSendCode ($code);

    if (!isset ($params ['Schoolname']))
      $params ['Schoolname'] = 'MyRoLos';
    $this->loginSchool ($params);
  }

}; // CLogin

function Login (&$params)
{
  $login = new CLogin;
  $login->Login ($params);
}

function LoginSchool (&$params)
{
  $login = new CLogin;
  $login->LoginSchool ($params);
}

function LoginCode (&$params)
{
  $login = new CLogin;
  $login->LoginCode ($params);
}

?>
